#include "area.h"

void activeRefresh(int area_x, int area_y) {
	XCopyArea(display, pixmaps[3], bufferPixmap, questGC, 0, 0, 
	          TILE_SIZE, TILE_SIZE, area_x*TILE_SIZE, area_y*TILE_SIZE);
	XFlush(display);
}

void areaStupidRefresh(map* map) {
	if(map->AREA_OX+XSPACES>MAX_MAP_X)
		fprintf(stderr,"areaStupidRefresh: area x out of map range\n");
	if(map->AREA_OY+YSPACES>MAX_MAP_Y)
		fprintf(stderr,"areaStupidRefresh: area y out of map range\n");
	StupidRefresh(map,map->AREA_OX,map->AREA_OY);
}

void SmartTileRefresh(map* map) {
	int x,y; 

	x = map->update[map->up_cnt-1].x;
	y = map->update[map->up_cnt-1].y;

	if(x>=map->AREA_OX && x<map->AREA_OX+XSPACES &&
	   y>=map->AREA_OY && y<map->AREA_OY+YSPACES) {
		XCopyArea(display, ChoosePixmap(map->cell[x][y]), bufferPixmap, questGC, 
		          0, 0, TILE_SIZE, TILE_SIZE, (x-map->AREA_OX)*TILE_SIZE, (y-map->AREA_OY)*TILE_SIZE);
		XFlush(display);
	}
	delUpdate(map);
}

void SmartRefresh(map* map) {
	while(map->up_cnt) SmartTileRefresh(map);
	XSync(display,0);
}

void moveArea(map* map, int dx, int dy) {
	int i = 0,
	    j = 0,
	    OLD_OX = map->AREA_OX, 
	    OLD_OY = map->AREA_OY;

	if(map->AREA_OX+dx>=0) {
		if(map->AREA_OX+XSPACES+dx<MAX_MAP_X) {
			map->AREA_OX=map->AREA_OX+dx;
		} else {
			map->AREA_OX=MAX_MAP_X-XSPACES;
		}
	} else {
		map->AREA_OX=0;
	}
	if(map->AREA_OY+dy>=0) {
		if(map->AREA_OY+YSPACES+dy<MAX_MAP_Y) {
			map->AREA_OY=map->AREA_OY+dy;
		} else {
			map->AREA_OY=MAX_MAP_Y-YSPACES;
		}
	} else {
		map->AREA_OY=0;
	}

	if(!(map->AREA_OX==OLD_OX && map->AREA_OY==OLD_OY)) {
		for(j=0;j<YSPACES;j++)
		for(i=0;i<XSPACES;i++) {
			addUpdate(map,map->AREA_OX+i,map->AREA_OY+j);
		}
	}
}

void absMoveArea(map* map, int x, int y) {
	moveArea(map,x-map->AREA_OX,y-map->AREA_OY);
}

void centerArea(map* map, int x, int y) {
	absMoveArea(map,x-(XSPACES/2),y-(YSPACES/2));
}


/* ---------------- old tty code :) ---------------- */

void ttyPrintArea(map *where, int ox, int oy, int dx, int dy) {
	int i,j;

	if(ox>=0 && oy>=0 && ox+dx<=MAX_MAP_X && oy+dy<=MAX_MAP_Y) {
		for(j=oy;j<oy+dy;j++) {
			for(i=ox;i<ox+dx;i++) {
				printf("%c",(where->cell[i][j]->mos)?'x':'.');
			}
			printf("\n");
		}
	} else {
		printf("illegal map area\n");
	}
}

void ttyPrintGoBack(int dx, int dy) {
	int i,j;

	for(j=0;j<dy;j++) {
		for(i=0;i<dx;i++) {
			printf("\b");
		}
		printf("\b\r");
	}
}
