#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include "combat.h"

int hitMonster(turn_list* tl, coord_list* cl, map* map,
               monster* tori, monster* uke, int attack) {
	int mod_thac0,
	    mod_ac,
	    attack_roll;

	if(tori && uke) {
	
		mod_thac0 = tori->thac0; /* add modifiers later */
		mod_ac    = uke->ac;     /* add modifiers later */
	
		srand(time(NULL));
		attack_roll = (rand()%20)+1;
	
		if(attack_roll >= (mod_thac0-mod_ac)) {
			printf("that was a hit! ");
			dmgMonster(tl,cl,map,tori,uke,attack);
			return 1;
		} else {
			if(tori->is_player) {
				printf("you missed.\n");
			} else {
				printf("you dodged the strike!\n");
			}
			return 0;
		}
	}
}
	
int dmgMonster(turn_list* tl, coord_list* cl, map* map,
               monster* tori, monster* uke, int attack) {

	if(uke->is_player) {
		printf("you got %d damage! %d/%d hp left\n",tori->dmg,uke->cur_hp,uke->max_hp);
	} else {
		printf("monster got %d damage!\n",tori->dmg);
	}

	uke->cur_hp -= tori->dmg;

	if(uke->cur_hp <= 0) {
		printf("it was a lethal blow! ");
		killMonster(tl,cl,map,uke);
	}
	return tori->dmg;
}

void killMonster(turn_list* tl, coord_list* cl, map* map, monster* who) {
	printf("%s is dead!\n",who->name);
	addUpdate(map,getX(cl,who),getY(cl,who));
	if(who->is_player) {
		printf("GAME OVER\n");
		exit(0);
	}
	delMonster(tl,cl,map,who);
}
