#ifndef COORD_H
#define COORD_H

#include "monster.h"	/* for the monster type */

#define VERBOSE_COORD_ERRORS	(0)

typedef struct coord_node {
	monster*	who;
	int		x;
	int		y;
} coord_node;

typedef struct coord_list {
	int		cnt;
	coord_node	node[MAX_MONSTERS];
} coord_list;

coord_list* newCoordList();
void        zapCoordList(coord_list* cl);

void addCoordMonster(coord_list* cl, monster* who, int x, int y);
void delCoordMonster(coord_list* cl, monster* who);

int getX(coord_list* cl, monster* who);
int getY(coord_list* cl, monster* who);

monster* getCoordMonster(coord_list* cl, int x, int y);

void moveCoord(coord_list* cl, int x, int y, int dx, int dy, int teleport);
void moveCoordMonster(coord_list* cl, monster* who, int dx, int dy, int teleport); 
/* if teleport==1 allow steps greater than 1 */

#endif /* COORD_H */
