#include "interface.h"
#include "monster.h"

static int key_ok;


void ParseKey(turn_list* tl, coord_list* cl, map* map, int down, XKeyEvent event) {
        int areax   = event.x/TILE_SIZE, 
	    areay   = event.y/TILE_SIZE,
	    bufsize = 20,
	    charcount;

	monster* me;
	
	char buffer[20]; /* you can use the buffer if you want to print what you're typing */
	KeySym key;

	charcount = XLookupString(&event,buffer,bufsize,&key,(NULL));
	me = tl->turn[tl->cur];


	if(down) {
		switch(key) {
			case XK_n : key_ok = 1; moveToNearestMonster(cl,map,me,0); break;
			case XK_m : key_ok = 1; moveToNearestMonster(cl,map,me,1); break;
			case XK_p : key_ok = 1; moveToNearestMonster(cl,map,me,2); break;

			case XK_a :
				if(   abs(getX(cl,me)-getX(cl,nearestMonster(cl,map,me,1)))<=1
				   && abs(getY(cl,me)-getY(cl,nearestMonster(cl,map,me,1)))<=1) {
					hitMonster(tl,cl,map,me,nearestMonster(cl,map,me,1),0); 
					key_ok = 1;
				} else {
					key_ok = 0;
				} break;

			case XK_q : key_ok = 1; printf("exit\n"); tl->game_control=quit; break;
			
			case XK_space : key_ok = 1; break; /* effectively works as "end turn" */

			case XK_Up    : key_ok = 1; moveMonster(cl,map,me, 0,-1,0); break;
			case XK_Right : key_ok = 1; moveMonster(cl,map,me, 1, 0,0); break;
			case XK_Down  : key_ok = 1; moveMonster(cl,map,me, 0, 1,0); break;
			case XK_Left  : key_ok = 1; moveMonster(cl,map,me,-1, 0,0); break;
			
			case XK_KP_Up        : key_ok = 1; moveMonster(cl,map,me, 0,-1,0); break;
			case XK_KP_Right     : key_ok = 1; moveMonster(cl,map,me, 1, 0,0); break;
			case XK_KP_Down      : key_ok = 1; moveMonster(cl,map,me, 0, 1,0); break;
			case XK_KP_Left      : key_ok = 1; moveMonster(cl,map,me,-1, 0,0); break;
			case XK_KP_Home      : key_ok = 1; moveMonster(cl,map,me,-1,-1,0); break;
			case XK_KP_Page_Up   : key_ok = 1; moveMonster(cl,map,me, 1,-1,0); break;
			case XK_KP_End       : key_ok = 1; moveMonster(cl,map,me,-1, 1,0); break;
			case XK_KP_Page_Down : key_ok = 1; moveMonster(cl,map,me, 1, 1,0); break;

			case XK_KP_7 : key_ok = 1; moveMonster(cl,map,me,-1,-1,0); break;
			case XK_KP_8 : key_ok = 1; moveMonster(cl,map,me, 0,-1,0); break;
			case XK_KP_9 : key_ok = 1; moveMonster(cl,map,me, 1,-1,0); break;
			case XK_KP_4 : key_ok = 1; moveMonster(cl,map,me,-1, 0,0); break;
			case XK_KP_6 : key_ok = 1; moveMonster(cl,map,me, 1, 0,0); break;
			case XK_KP_1  : key_ok = 1; moveMonster(cl,map,me,-1, 1,0); break;
			case XK_KP_2  : key_ok = 1; moveMonster(cl,map,me, 0, 1,0); break;
			case XK_KP_3  : key_ok = 1; moveMonster(cl,map,me, 1, 1,0); break;

			default       : key_ok = 0; break;
		}
	} else {
		if(key_ok && tl->game_control!=quit) tl->game_control=no_action;
	}
}

void ParseButton(turn_list* tl, coord_list* cl, map* map, int down, XButtonEvent event) {
        int areax  = (event.x/TILE_SIZE)+map->AREA_OX,
	    areay  = (event.y/TILE_SIZE)+map->AREA_OY,
	    winx   = event.x,
	    winy   = event.y,
	    button = event.button;

	monster* mos;

        switch(button) {
        case 1:
                if(down) {
                        downx=areax;
                        downy=areay;
                } else {
                       	moveMonster(cl,map,getCoordMonster(cl,downx,downy),areax-downx,areay-downy,1);
			centerArea(map,areax,areay);
			SmartRefresh(map);
                       	PasteBufferToWindow(); 
                } break;
        case 2:
		if(down) {
			if(mos=map->cell[areax][areay]->mos) {
				printf("the %s on that space is called %s - %d\n",
			               (mos->is_player)?"player":"monster",mos->name,mos->race);
			}
		} else {

		} break;
        case 3:
		if(down) {

		} else {
                	printf("exit\n");
			tl->game_control=quit;
		} break;
        }

	/* put this in any event to pass on your turn
	tl->game_control=no_action;
	*/

}     

void PrintCommandlineHelp() {
fprintf(stdout,"
Quest 0.0.7

The current mouse functions are:
Left   - hacky function, move any monster
Middle - print the monster's name
Right  - quit

The keyboard:
n      - move to nearest being
p      - move to nearest player
m      - move to nearest monster
a      - attack a monster next to you
q      - quit

use the keypad or the direction keys for movement
and if you don't want to do anything the spacebar passes on your turn.

The signals (like ^C) aren't dealt with in a proper way yet.

Have fun...

");
}
