#ifndef LISTS_H
#define LISTS_H

#include "map.h"	/* for the map */
#include "turn.h"	/* for the turn list */
#include "coord.h"	/* for the coord list */

#define VERBOSE_LIST_ERRORS	(0)


void addMonster(turn_list *tl, coord_list *cl, map *map, monster* who, int x, int y);
void delMonster(turn_list *tl, coord_list *cl, map *map, monster* who);
void moveMonster(coord_list *cl, map *map, monster* who, int dx, int dy, int teleport);
void delAllMonsters(turn_list *tl, coord_list *cl, map *map);

void relMoveMonster(coord_list *cl, map *map, monster* who, int ox, int oy, int tox, int toy);
void moveToMonster(coord_list *cl, map *map, monster* who, monster* to);
void moveToNearestMonster(coord_list *cl, map *map, monster* who, int friendfoe);

void centerAreaOnMonster(coord_list* cl, monster* who);

monster* nearestMonster(coord_list *cl, map *map, monster* who, int friendfoe);
/* friendfoe:
   0: search for any monster
   1: search for npc
   2: search for pc */

#endif /* LISTS_H */

