#include <string.h>	/* for strcpy() */
#include "map.h"	/* for the access enumeration */
#include "monster.h"

monster* newMonster(char* name, int race) {
	monster* new;
	new=(monster*)malloc(sizeof(monster));

	setMonsterName(new,name);

	new->is_player	= 0;
	new->race	= race;

	/*
	if you want to give a monster more than one access right
	you should put a bitwise OR between the types...
	e.g. monster wlm can swim and fly would become:
	wlm->access = swim | fly;
	that causes wlm to be able to access spaces with
	swim, fly, swim and fly rights, but not the rest.
	*/
	switch(race) {
		case human:
			new->access	= walk | swim;
			new->max_hp	= 10;
			new->cur_hp	= 10;
			new->ac		= 8;
			new->thac0	= 18;
			new->dmg	= 4;
			break;
		case orc:
			new->access	= walk; 
			new->max_hp	= 8;
			new->cur_hp	= 8;
			new->ac		= 10;
			new->thac0	= 20;
			new->dmg	= 3;
			break;
		default:
			new->access	= walk; 
			new->max_hp	= 1;
			new->cur_hp	= 1;
			new->ac		= 10;
			new->thac0	= 20;
			new->dmg	= 0;
			break;
	}

	return new;
}

void zapMonster(monster* who) {
	free(who);
	who=NULL;
}

void setMonsterName(monster* who, char* name) {
	strcpy(who->name,name);
}

char* getMonsterName(monster* who) {
	return who->name;
}
