#ifndef TURN_H
#define TURN_H

#include "monster.h"	/* for the monster type */
#include "coord.h"	/* for the coord list */
#include "map.h"	/* for the map */

#define VERBOSE_TURN_ERRORS	(0)

#define PLAYER_HIGHLIGHTING	(0)
/* Player highlighting is a very handy function if you have
   two or more player characters in the visual map area.
   If PLAYER_HIGHLIGHTING is 1 the map window will be updated
   an extra time when every player onscreen has his turn
   and the active player will be highlighted. */

#define NPC_REFRESH		(0)
/* When npc refreshing is on the view area is refreshed when
   each npc has his turn, instead of at the end of the deal */


static int game_control;
enum game_control_options {
	quit,		/* 0, skip all further turns in the deal and quit */
	no_action,	/* 1, end of turn */
	npc,		/* 2, npc's turn... todo() will be called */
	pc		/* 3, pc's turn... listen() will be called */
};

typedef struct turn_list {
	int		cnt;
	int		cur;
	int		game_control;
	monster*	turn[MAX_MONSTERS];
} turn_list;

turn_list* newTurnList();
void       zapTurnList(turn_list* tl);

void addTurnMonster(turn_list* tl, monster* who);
void delTurnMonster(turn_list* tl, monster* who);

monster* whoTurn(turn_list* tl);

void nextTurn(turn_list* tl);
void doTurn(turn_list* tl, coord_list* cl, map* map);
void dealTurn(turn_list* tl, coord_list* cl, map* map);

void decideGameControl(turn_list* tl);

#endif /* TURN_H */
