#include "xfuncs.h"

void GrabStuff(void) {
        XGrabServer(display);
        XGrabPointer(display, MapWin, True, ButtonPressMask | ButtonReleaseMask | PointerMotionMask, GrabModeAsync, GrabModeAsync, MapWin, None, CurrentTime);
        XGrabKeyboard(display, MapWin, True, GrabModeAsync, GrabModeAsync, CurrentTime);
}

void CreateWindow(int winx,int winy,int winw,int winh,char *wintitle) {
        XSetWindowAttributes WinAttr;
        XTextProperty        WindowName;
        XSizeHints          *SizeHints;
        XWMHints            *WMHints;
        XClassHint          *ClassHints;
        XGCValues            GCV;
        XColor               Cell;

        int x;


        WinAttr.background_pixel=0;
        WinAttr.colormap=DefaultColormap;
        MapWin = XCreateWindow(display, RootWin, winx, winy, winw, winh, 0, CopyFromParent, InputOutput, CopyFromParent, CWColormap | CWBackPixel , &WinAttr);

        if (!(SizeHints = XAllocSizeHints()))
          {printf("Error allocating X-structure (size-hints)\n");exit(-1);}
        if (!(ClassHints = XAllocClassHint()))
          {printf("Error allocating X-structure (class-hints)\n");exit(-1);}
        if (!(WMHints = XAllocWMHints()))
          {printf("Error allocating X-structure (WM-hints)\n");exit(-1);}
        if (!XStringListToTextProperty(&wintitle, 1, &WindowName))
          {printf("Error allocating X-structure (window-name)\n");exit(-1);}

        /* set size hints */
        SizeHints->flags = PPosition | PSize;
        SizeHints->x = winx;
        SizeHints->y = winy;
        SizeHints->width = winw;
        SizeHints->height = winh;
        /* set class hints */
        ClassHints->res_name = "Pasta";
        ClassHints-> res_class = "Pasta";
        WMHints->flags = 0;   /* no wm hints */
        XSetWMProperties(display, MapWin, &WindowName, &WindowName, NULL, 0, SizeHints, WMHints, ClassHints);

        XFree(SizeHints);
        XFree(WMHints);
        XFree(ClassHints);


        XSelectInput(display, MapWin, ButtonPressMask | ButtonReleaseMask | PointerMotionMask | KeyPressMask | KeyReleaseMask | ExposureMask | SubstructureNotifyMask);

        if (!(questFont = XLoadQueryFont(display, TextFont)))
        {
                printf("Could not open font %s\n", TextFont);
                exit(-1);
        }
        GCV.font = questFont->fid;
 
        questGC = XCreateGC(display, RootWin, 0, &GCV);
        XMapWindow(display, MapWin);

        for (x = 0; x < 256; x++)
        {
                Cell.pixel = x;
                Cell.flags = DoRed | DoGreen | DoBlue;
                XQueryColor(display, DefaultColormap, &Cell);
        }

        return;
}

void InitXWindows() {
        //w get display and info etc etc...
        int x,y;

        if ( (display = XOpenDisplay(NULL)) == NULL )
        {
                printf("display error\n");
                exit( -1 );
        }

        ScreenNum = DefaultScreen(display);
        RootWin = RootWindow(display, ScreenNum);
        DefaultVisual = DefaultVisual(display,ScreenNum);
        DefaultColormap = DefaultColormap(display,ScreenNum);
        ScreenWidth = DisplayWidth(display, ScreenNum);
        ScreenHeight = DisplayHeight(display, ScreenNum);
}


Pixmap ChoosePixmap(space* space) {

        if(space->mos == NULL) {
		switch(space->type) {
			case grass : if(space->status) return pixmaps[4];
			             else              return pixmaps[5];
			case pine  : if(space->status) return pixmaps[6];
			             else              return pixmaps[7];
			case rock  : if(space->status) return pixmaps[8];
			             else              return pixmaps[9];
			default    : return pixmaps[0];
		}
	}
        else  {
                if(space->mos->is_player) return pixmaps[2];
                else                      return pixmaps[1];
        }
}

void StupidRefresh(map* map, int ox, int oy) {
        int i,j,WindowX, WindowY;

        for(j=0;j<YSPACES;j++) {
                for(i=0;i<XSPACES;i++) {
                        WindowX=i*TILE_SIZE;
                        WindowY=j*TILE_SIZE;
                        XCopyArea(display, ChoosePixmap(map->cell[ox+i][oy+j]), bufferPixmap, questGC, 0, 0, TILE_SIZE, TILE_SIZE, WindowX, WindowY);
                        XFlush(display);
                }
        }
        XSync(display,0);
}


void PasteBufferToWindow() {
        XCopyArea(display, bufferPixmap, MapWin, questGC, 0, 0, XSPACES*TILE_SIZE, YSPACES*TILE_SIZE, 0, 0);
}

void LoadPixmaps() {

        //w the bufferPixmap is a pixmap I where I update all the changes
        //w to the screen, then when everything is ready I put THIS pixmap
        //w in the window, I don't go refresh the window for every little fart.
        bufferPixmap = XCreatePixmap(display, MapWin, XSPACES*TILE_SIZE, YSPACES*TILE_SIZE, DefaultDepth(display, DefaultScreen(display)));

        //w reading the xpm files and making pixmaps from them.
        XpmReadFileToPixmap(display, MapWin, "./xpm/empty.xpm", &pixmaps[0],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);


        XpmReadFileToPixmap(display, MapWin, "./xpm/monster.xpm", &pixmaps[1],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);

        XpmReadFileToPixmap(display, MapWin, "./xpm/player.xpm", &pixmaps[2],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);

        XpmReadFileToPixmap(display, MapWin, "./xpm/active.xpm", &pixmaps[3],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);


        XpmReadFileToPixmap(display, MapWin, "./xpm/grass_1.xpm", &pixmaps[4],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
        XpmReadFileToPixmap(display, MapWin, "./xpm/grass_2.xpm", &pixmaps[5],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
        XpmReadFileToPixmap(display, MapWin, "./xpm/pine_1.xpm", &pixmaps[6],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
        XpmReadFileToPixmap(display, MapWin, "./xpm/pine_2.xpm", &pixmaps[7],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
        XpmReadFileToPixmap(display, MapWin, "./xpm/rock_1.xpm", &pixmaps[8],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
        XpmReadFileToPixmap(display, MapWin, "./xpm/rock_2.xpm", &pixmaps[9],
                            (Pixmap *) NULL, (XpmAttributes *) NULL);
} 


void InitMapWindow(map* map) {

        PrintCommandlineHelp();

        InitXWindows();

        //w the 50,50 are root screen coordinates where to put the window
        CreateWindow(50,50,XSPACES*TILE_SIZE,YSPACES*TILE_SIZE,
                     "Quest 0.0.7");

        LoadPixmaps();

        areaStupidRefresh(map);

        //w and here goes the finished buffer pixmap into the window
        PasteBufferToWindow();
}
