#ifndef XFUNCS_H
#define XFUNCS_H

#include <stdlib.h>
#include <stdio.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/Xatom.h>

#include <X11/xpm.h>

/* for functions I still have to improve:
   the signal handler and wait() */
#include <signal.h> 
#include <time.h>

#include "monster.h"	/* for the monster type */
#include "area.h"	/* for AREA_OX and AREA_OY */
#include "lists.h"	/* for pixmap determination */


typedef int bool;
#define true       (1)
#define false      (0)


static int TILE_SIZE = 16,
           XSPACES   = 16,
           YSPACES   = 16;

Display  *display;
Window   RootWin,
         MapWin;
Visual   *DefaultVisual;
GC       questGC;
XImage   *questI;
Colormap DefaultColormap,
         questColormap;
XColor   ColorCount[256];

char     *Image,
         *Background;
int      ScreenWidth,
         ScreenHeight,
         ScreenNum;

unsigned long int *Image32,
                  *Background32;

XFontStruct *questFont;
static char *TextFont = "lucidasanstypewriter-bold-24",
            *DisplayString = NULL;


int downx,
    downy;

/* for now a few pixmaps to draw with,
   later we make a list of all the pixmaps we use. */

Pixmap bufferPixmap,
       pixmaps[10];



void GrabStuff(void);
void CreateWindow(int winx,int winy,int winw,int winh,char *wintitle);
void InitXWindows();

void StupidRefresh(map* map,int ox,int oy);

Pixmap ChoosePixmap(space* space);
void   LoadPixmaps();
void   PasteBufferToWindow();

void InitMapWindow(map* map);


#endif /* XFUNCS_H */
